Index: issm/trunk/src/c/modules/ModelProcessorx/Dakota/CreateParametersDakota.cpp
===================================================================
--- issm/trunk/src/c/modules/ModelProcessorx/Dakota/CreateParametersDakota.cpp	(revision 13405)
+++ issm/trunk/src/c/modules/ModelProcessorx/Dakota/CreateParametersDakota.cpp	(revision 13975)
@@ -16,9 +16,7 @@
 
 	/*variable declarations: {{{*/
-	int i,j,k;
-	
+	int i;
 	Parameters* parameters = NULL;
-	int      second_count;
-	
+
 	int*     part=NULL;
 	double*  dpart=NULL;
@@ -35,21 +33,8 @@
 	char* qmuerrname=NULL;
 	char* qmuoutname=NULL;
-	
+
 	//descriptors:
 	char tag[50];
-	
-	/*parameters for mass flux: */
-	bool     qmu_mass_flux_present=false;
-	int qmu_mass_flux_num_profiles=0;
-	double** array=NULL;
-	int*     mdims_array=NULL;
-	int*     ndims_array=NULL;
-	
-	double*  matrix=NULL;
-	double*  temp_matrix=NULL;
-	int      M;
-	int      temp_m,temp_n;
-	int      m,n;
-	int      count;
+
 	bool     dakota_analysis=false;
 	char*    name=NULL;
@@ -60,5 +45,5 @@
 
 	/*}}}*/
-	
+
 	/*recover parameters : */
 	parameters=*pparameters;
@@ -102,5 +87,5 @@
 		/*Deal with partitioning: {{{*/
 		/*partition vertices in iomodel->qmu_npart parts, unless a partition is already present: */
-		
+
 		parameters->AddObject(iomodel->CopyConstantObject(QmuNumberofpartitionsEnum));
 		iomodel->FetchData(&dpart,NULL,NULL,QmuPartitionEnum);
@@ -117,5 +102,5 @@
 		/*}}}*/
 		/*Deal with data needed because of qmu variables: {{{*/
-		
+
 		for(i=0;i<numvariabledescriptors;i++){
 
@@ -123,5 +108,5 @@
 				/*Ok, we are dealing with a variable that is distributed over nodes. Recover the name of the variable (ex: scaled_Thickness): */
 				sscanf(variabledescriptors[i],"scaled_%s",tag);
-				
+
 				/*Recover data: */
 				iomodel->FetchData(&dakota_parameter,&nrows,&ncols,StringToEnumx(tag));
@@ -134,69 +119,8 @@
 					parameters->AddObject(new DoubleTransientMatParam(StringToEnumx(tag),dakota_parameter,nrows,ncols));
 				}
-				
+
 				/*Free ressources:*/
 				xDelete<double>(dakota_parameter);
 			}
-		}
-		/*}}}*/
-		/*Deal with data needed to compute qmu responses: {{{*/
-		for(i=0;i<numresponsedescriptors;i++){
-			
-			if(strncmp(responsedescriptors[i],"indexed_MassFlux",16)==0){
-				qmu_mass_flux_present=true;
-			}
-		}
-		
-		
-		if(qmu_mass_flux_present){
-			
-			/*Fetch the mass flux segments necessary to compute the mass fluxes.  Build a DoubleMatArrayParam object out of them: */ 
-			iomodel->FetchData(&array,&mdims_array,&ndims_array,&qmu_mass_flux_num_profiles,QmuMassFluxSegmentsEnum);
-			if(qmu_mass_flux_num_profiles==0)_error_("qmu_mass_flux_num_profiles is 0, when MassFlux computations were requested!");
-
-			/*Go through segments, and extract those that belong to this cpu: */
-			for(i=0;i<qmu_mass_flux_num_profiles;i++){
-				temp_matrix=array[i];
-				temp_m=mdims_array[i];
-				temp_n=ndims_array[i];
-
-				m=0;
-				for(j=0;j<temp_m;j++){
-					if (  iomodel->my_elements[(int)(*(temp_matrix+5*j+4))-1])m++;
-				}
-				if(m){
-					matrix=xNewZeroInit<double>(5*m);
-					count=0;
-					for(j=0;j<temp_m;j++){
-						if (iomodel->my_elements[(int)*(temp_matrix+5*j+4)-1]){
-							for(k=0;k<5;k++)*(matrix+5*count+k)=*(temp_matrix+5*j+k);
-							count++;
-						}
-					}
-				}
-				else{
-					matrix=NULL;
-				}
-
-				/*Assign: */
-				array[i]=matrix;
-				mdims_array[i]=m;
-				ndims_array[i]=5;
-
-				/*Free temporary matrix: */
-				xDelete<double>(temp_matrix);
-			}
-
-			/*Ok, we have an array of segments, different on every cpu. Create a DoubleMatArrayParam object with it: */
-			parameters->AddObject(new DoubleMatArrayParam(QmuMassFluxSegmentsEnum,array,qmu_mass_flux_num_profiles,mdims_array,ndims_array));
-
-			/*Free data: */
-			for(i=0;i<qmu_mass_flux_num_profiles;i++){
-				double* matrix=array[i];
-				xDelete<double>(matrix);
-			}
-			xDelete<int>(mdims_array); 
-			xDelete<int>(ndims_array);
-			xDelete<double*>(array);
 		}
 		/*}}}*/
Index: issm/trunk/src/c/modules/ModelProcessorx/DiagnosticHoriz/CreateConstraintsDiagnosticHoriz.cpp
===================================================================
--- issm/trunk/src/c/modules/ModelProcessorx/DiagnosticHoriz/CreateConstraintsDiagnosticHoriz.cpp	(revision 13405)
+++ issm/trunk/src/c/modules/ModelProcessorx/DiagnosticHoriz/CreateConstraintsDiagnosticHoriz.cpp	(revision 13975)
@@ -44,5 +44,4 @@
 	Constraints *constraints      = NULL;
 	SpcStatic   *spcstatic        = NULL;
-	int          node1,node2;
 	int          dim;
 	int          numberofvertices;
@@ -64,5 +63,5 @@
 	/*Create constraints if they do not exist yet*/
 	if(!constraints) constraints = new Constraints();
-	
+
 	/*Now, is the flag macayaealpattyn on? otherwise, do nothing: */
 	if(!ismacayealpattyn & !isstokes & !isl1l2){
@@ -70,5 +69,5 @@
 		return;
 	}
-	
+
 	/*Constraints: fetch data: */
 	iomodel->FetchData(&spcvx,&Mx,&Nx,DiagnosticSpcvxEnum);
@@ -324,5 +323,5 @@
 		}
 	}
-	  
+
 	/*Free data: */
 	iomodel->DeleteData(spcvx,DiagnosticSpcvxEnum);
Index: issm/trunk/src/c/modules/ModelProcessorx/DiagnosticHoriz/CreateLoadsDiagnosticHoriz.cpp
===================================================================
--- issm/trunk/src/c/modules/ModelProcessorx/DiagnosticHoriz/CreateLoadsDiagnosticHoriz.cpp	(revision 13405)
+++ issm/trunk/src/c/modules/ModelProcessorx/DiagnosticHoriz/CreateLoadsDiagnosticHoriz.cpp	(revision 13975)
@@ -14,7 +14,5 @@
 
 	/*DataSets*/
-	Loads     *loads     = NULL;
 	Icefront  *icefront  = NULL;
-	Riftfront *riftfront = NULL;
 	Pengrid   *pengrid   = NULL;
 
@@ -48,5 +46,5 @@
 
 	/*Recover pointer: */
-	loads=*ploads;
+	Loads* loads=*ploads;
 
 	/*Create loads if they do not exist yet*/
@@ -58,5 +56,5 @@
 		return;
 	}
-	
+
 	/*Create pressure loads as boundary conditions. Pay attention to the partitioning if we are running in parallel (the nodes
 	 * referenced by a certain load must belong to the cluster node): */
@@ -70,5 +68,5 @@
 	/*First load data:*/
 	for (i=0;i<numberofpressureloads;i++){
-		
+
 		/*Retrieve element to which this icefront belongs: */
 		if (dim==2) segment_width=4; 
@@ -78,5 +76,5 @@
 		/*Now, if this element is not in the partition, pass: */
 		if(!iomodel->my_elements[element]) continue;
-		
+
 		/*Do not create ice front if Hutter or Stokes elements*/
 		if (reCast<int,IssmDouble>(*(elements_type+element))==HutterApproximationEnum) continue;
@@ -132,8 +130,7 @@
 	iomodel->DeleteData(pressureload,DiagnosticIcefrontEnum);
 
-
 	/*Create Penpair for penalties: */
 	iomodel->FetchData(&penalties,&numpenalties,NULL,DiagnosticVertexPairingEnum);
-	
+
 	for(i=0;i<numpenalties;i++){
 
@@ -167,5 +164,5 @@
 		}
 		iomodel->DeleteData(5,RiftsRiftstructEnum,ThicknessEnum,BedEnum,SurfaceEnum,MaskVertexonfloatingiceEnum);
-		xDelete<Riftfront>(riftfront);
+		xDelete<IssmDouble>(riftinfo);
 	}
 
Index: issm/trunk/src/c/modules/ModelProcessorx/DiagnosticHoriz/CreateNodesDiagnosticHoriz.cpp
===================================================================
--- issm/trunk/src/c/modules/ModelProcessorx/DiagnosticHoriz/CreateNodesDiagnosticHoriz.cpp	(revision 13405)
+++ issm/trunk/src/c/modules/ModelProcessorx/DiagnosticHoriz/CreateNodesDiagnosticHoriz.cpp	(revision 13975)
@@ -21,7 +21,4 @@
 	bool   isstokes,isl1l2,ismacayealpattyn;
 
-	/*DataSets: */
-	Nodes*    nodes = NULL;
-
 	/*Fetch parameters: */
 	iomodel->Constant(&numberofvertices,MeshNumberofverticesEnum);
@@ -31,9 +28,9 @@
 
 	/*Recover pointer: */
-	nodes=*pnodes;
+	Nodes* nodes=*pnodes;
 
 	/*First create nodes*/
 	if(!nodes) nodes = new Nodes();
-	
+
 	/*Now, is the flag macayaealpattyn on? otherwise, do nothing: */
 	if(!ismacayealpattyn & !isstokes & !isl1l2){
@@ -48,9 +45,9 @@
 	iomodel->FetchData(9,MeshVertexonbedEnum,MeshVertexonsurfaceEnum,FlowequationBordermacayealEnum,FlowequationBorderstokesEnum,
 				MaskVertexongroundediceEnum,MaskVertexonfloatingiceEnum,MaskVertexonwaterEnum,FlowequationVertexEquationEnum,DiagnosticReferentialEnum);
-	
+
 	for (i=0;i<numberofvertices;i++){
 
 		if(iomodel->my_vertices[i]){
-			
+
 			/*Add node to nodes dataset: */
 			nodes->AddObject(new Node(iomodel->nodecounter+i+1,i,i+1,i,iomodel,DiagnosticHorizAnalysisEnum));
Index: issm/trunk/src/c/modules/ModelProcessorx/DiagnosticHutter/CreateLoadsDiagnosticHutter.cpp
===================================================================
--- issm/trunk/src/c/modules/ModelProcessorx/DiagnosticHutter/CreateLoadsDiagnosticHutter.cpp	(revision 13405)
+++ issm/trunk/src/c/modules/ModelProcessorx/DiagnosticHutter/CreateLoadsDiagnosticHutter.cpp	(revision 13975)
@@ -13,13 +13,10 @@
 void	CreateLoadsDiagnosticHutter(Loads** ploads, IoModel* iomodel){
 
-	/*DataSet*/
-	Loads* loads=NULL;
-
 	/*Recover pointer: */
-	loads=*ploads;
+	Loads* loads=*ploads;
 
 	/*Create loads if they do not exist yet*/
 	if(!loads) loads = new Loads();
-	
+
 	/*Assign output pointer: */
 	*ploads=loads;
Index: issm/trunk/src/c/modules/ModelProcessorx/DiagnosticHutter/CreateNodesDiagnosticHutter.cpp
===================================================================
--- issm/trunk/src/c/modules/ModelProcessorx/DiagnosticHutter/CreateNodesDiagnosticHutter.cpp	(revision 13405)
+++ issm/trunk/src/c/modules/ModelProcessorx/DiagnosticHutter/CreateNodesDiagnosticHutter.cpp	(revision 13975)
@@ -21,7 +21,4 @@
 	bool   ishutter;
 
-	/*DataSets: */
-	Nodes*    nodes = NULL;
-
 	/*Fetch parameters: */
 	iomodel->Constant(&numberofvertices,MeshNumberofverticesEnum);
@@ -29,5 +26,5 @@
 
 	/*Recover pointer: */
-	nodes=*pnodes;
+	Nodes* nodes=*pnodes;
 
 	/*Create nodes if they do not exist yet*/
Index: issm/trunk/src/c/modules/ModelProcessorx/DiagnosticVert/CreateConstraintsDiagnosticVert.cpp
===================================================================
--- issm/trunk/src/c/modules/ModelProcessorx/DiagnosticVert/CreateConstraintsDiagnosticVert.cpp	(revision 13405)
+++ issm/trunk/src/c/modules/ModelProcessorx/DiagnosticVert/CreateConstraintsDiagnosticVert.cpp	(revision 13975)
@@ -20,7 +20,4 @@
 	int    numberofvertices;
 
-	/*Output*/
-	Constraints* constraints = NULL;
-
 	/*Fetch parameters: */
 	iomodel->Constant(&dim,MeshDimensionEnum);
@@ -29,5 +26,5 @@
 
 	/*Recover pointer: */
-	constraints=*pconstraints;
+	Constraints* constraints=*pconstraints;
 
 	/*Create constraints if they do not exist yet*/
Index: issm/trunk/src/c/modules/ModelProcessorx/DiagnosticVert/CreateLoadsDiagnosticVert.cpp
===================================================================
--- issm/trunk/src/c/modules/ModelProcessorx/DiagnosticVert/CreateLoadsDiagnosticVert.cpp	(revision 13405)
+++ issm/trunk/src/c/modules/ModelProcessorx/DiagnosticVert/CreateLoadsDiagnosticVert.cpp	(revision 13975)
@@ -13,9 +13,6 @@
 void	CreateLoadsDiagnosticVert(Loads** ploads, IoModel* iomodel){
 
-	/*DataSet*/
-	Loads* loads=NULL;
-
 	/*Recover pointer: */
-	loads=*ploads;
+	Loads* loads=*ploads;
 
 	/*Create loads if they do not exist yet*/
Index: issm/trunk/src/c/modules/ModelProcessorx/DiagnosticVert/CreateNodesDiagnosticVert.cpp
===================================================================
--- issm/trunk/src/c/modules/ModelProcessorx/DiagnosticVert/CreateNodesDiagnosticVert.cpp	(revision 13405)
+++ issm/trunk/src/c/modules/ModelProcessorx/DiagnosticVert/CreateNodesDiagnosticVert.cpp	(revision 13975)
@@ -21,7 +21,4 @@
 	int    numberofvertices;
 
-	/*DataSets: */
-	Nodes*    nodes = NULL;
-
 	/*Fetch parameters: */
 	iomodel->Constant(&dim,MeshDimensionEnum);
@@ -29,5 +26,5 @@
 
 	/*Recover pointer: */
-	nodes=*pnodes;
+	Nodes* nodes=*pnodes;
 
 	/*Create nodes if they do not exist yet*/
@@ -42,5 +39,5 @@
 	/*Continuous Galerkin partition of nodes: */
 	NodesPartitioning(&iomodel->my_nodes,iomodel->my_elements,iomodel->my_vertices,iomodel,continuous_galerkin);
-	
+
 	/*First fetch data: */
 	iomodel->FetchData(6,MeshVertexonbedEnum,MeshVertexonsurfaceEnum,MaskVertexongroundediceEnum,MaskVertexonfloatingiceEnum,FlowequationVertexEquationEnum,MaskVertexonwaterEnum);
@@ -57,5 +54,5 @@
 	/*Clean fetched data: */
 	iomodel->DeleteData(6,MeshVertexonbedEnum,MeshVertexonsurfaceEnum,MaskVertexongroundediceEnum,MaskVertexonfloatingiceEnum,FlowequationVertexEquationEnum,MaskVertexonwaterEnum);
-	
+
 	/*Assign output pointer: */
 	*pnodes=nodes;
Index: issm/trunk/src/c/modules/ModelProcessorx/DistributeNumDofs.cpp
===================================================================
--- issm/trunk/src/c/modules/ModelProcessorx/DistributeNumDofs.cpp	(revision 13405)
+++ issm/trunk/src/c/modules/ModelProcessorx/DistributeNumDofs.cpp	(revision 13975)
@@ -6,5 +6,5 @@
 #include "../../include/include.h"
 #include "../../EnumDefinitions/EnumDefinitions.h"
-	
+
 void DistributeNumDofs(DofIndexing* index,int analysis_type,IssmDouble* vertices_type){
 
@@ -13,5 +13,4 @@
 
 	int numdofs=2; //default numdofs
-	int i;
 	int* doftype=NULL;
 
Index: issm/trunk/src/c/modules/ModelProcessorx/ElementsAndVerticesPartitioning.cpp
===================================================================
--- issm/trunk/src/c/modules/ModelProcessorx/ElementsAndVerticesPartitioning.cpp	(revision 13405)
+++ issm/trunk/src/c/modules/ModelProcessorx/ElementsAndVerticesPartitioning.cpp	(revision 13975)
@@ -22,6 +22,6 @@
 	int i;
 
-	extern int my_rank;
-	extern int num_procs;
+	int my_rank;
+	int num_procs;
 	int    numberofelements;
 	int    numberofvertices;
@@ -46,4 +46,8 @@
 	IssmDouble* riftinfo=NULL;
 	IssmDouble* vertex_pairing=NULL;
+
+	/*Get my_rank:*/
+	my_rank=IssmComm::GetRank();
+	num_procs=IssmComm::GetSize();
 
 	/*Fetch parameters: */
@@ -102,5 +106,5 @@
 
 			my_elements[i]=true;
-			
+
 			/*Now that we are here, we can also start building the list of vertices belonging to this cpu partition: we use 
 			 *the  element index to do this. For each element n, we know index[n][0:2] holds the indices (matlab indexing) 
@@ -110,5 +114,5 @@
 			my_vertices[reCast<int>(*(elements+elements_width*i+1))-1]=1;
 			my_vertices[reCast<int>(*(elements+elements_width*i+2))-1]=1;
-			
+
 			if(elements_width==6){
 				my_vertices[reCast<int>(*(elements+elements_width*i+3))-1]=1;
Index: issm/trunk/src/c/modules/ModelProcessorx/Enthalpy/CreateConstraintsEnthalpy.cpp
===================================================================
--- issm/trunk/src/c/modules/ModelProcessorx/Enthalpy/CreateConstraintsEnthalpy.cpp	(revision 13405)
+++ issm/trunk/src/c/modules/ModelProcessorx/Enthalpy/CreateConstraintsEnthalpy.cpp	(revision 13975)
@@ -23,10 +23,9 @@
 	IssmDouble heatcapacity;
 	IssmDouble referencetemperature;
-	
+
 	/*Output*/
 	IssmDouble *spcvector  = NULL;
 	IssmDouble* times=NULL;
 	IssmDouble* values=NULL;
-	Constraints* constraints = NULL;
 
 	/*Fetch parameters: */
@@ -37,5 +36,5 @@
 
 	/*Recover pointer: */
-	constraints=*pconstraints;
+	Constraints* constraints=*pconstraints;
 
 	/*Create constraints if they do not exist yet*/
@@ -85,5 +84,5 @@
 		/*Create constraints from x,y,z: */
 		for (i=0;i<numberofvertices;i++){
-			
+
 			/*keep only this partition's nodes:*/
 			if((iomodel->my_vertices[i])){
Index: issm/trunk/src/c/modules/ModelProcessorx/Enthalpy/CreateLoadsEnthalpy.cpp
===================================================================
--- issm/trunk/src/c/modules/ModelProcessorx/Enthalpy/CreateLoadsEnthalpy.cpp	(revision 13405)
+++ issm/trunk/src/c/modules/ModelProcessorx/Enthalpy/CreateLoadsEnthalpy.cpp	(revision 13975)
@@ -13,14 +13,10 @@
 void	CreateLoadsEnthalpy(Loads** ploads, IoModel* iomodel){
 
-	/*DataSet*/
-	Loads* loads=NULL;
-
 	/*Recover pointer: */
-	loads=*ploads;
+	Loads* loads=*ploads;
 
 	/*Create loads if they do not exist yet*/
 	if(!loads) loads = new Loads();
 
-
 	/*Assign output pointer: */
 	*ploads=loads;
Index: issm/trunk/src/c/modules/ModelProcessorx/Enthalpy/CreateNodesEnthalpy.cpp
===================================================================
--- issm/trunk/src/c/modules/ModelProcessorx/Enthalpy/CreateNodesEnthalpy.cpp	(revision 13405)
+++ issm/trunk/src/c/modules/ModelProcessorx/Enthalpy/CreateNodesEnthalpy.cpp	(revision 13975)
@@ -20,12 +20,9 @@
 	int    numberofvertices;
 
-	/*DataSets: */
-	Nodes*    nodes = NULL;
-
 	/*Fetch parameters: */
 	iomodel->Constant(&numberofvertices,MeshNumberofverticesEnum);
-	
+
 	/*Recover pointer: */
-	nodes=*pnodes;
+	Nodes* nodes=*pnodes;
 
 	/*Create nodes if they do not exist yet*/
@@ -40,5 +37,5 @@
 	for (i=0;i<numberofvertices;i++){
 		if(iomodel->my_vertices[i]){
-			
+
 			/*Add node to nodes dataset: */
 			nodes->AddObject(new Node(iomodel->nodecounter+i+1,i,i+1,i,iomodel,EnthalpyAnalysisEnum));
@@ -49,5 +46,5 @@
 	/*Clean fetched data: */
 	iomodel->DeleteData(6,MeshVertexonbedEnum,MeshVertexonsurfaceEnum,MaskVertexongroundediceEnum,MaskVertexonfloatingiceEnum,FlowequationVertexEquationEnum,MaskVertexonwaterEnum);
-	
+
 	/*Assign output pointer: */
 	*pnodes=nodes;
Index: issm/trunk/src/c/modules/ModelProcessorx/Hydrology/CreateConstraintsHydrology.cpp
===================================================================
--- issm/trunk/src/c/modules/ModelProcessorx/Hydrology/CreateConstraintsHydrology.cpp	(revision 13405)
+++ issm/trunk/src/c/modules/ModelProcessorx/Hydrology/CreateConstraintsHydrology.cpp	(revision 13975)
@@ -14,14 +14,11 @@
 void	CreateConstraintsHydrology(Constraints** pconstraints, IoModel* iomodel){
 
-	/*Output*/
-	Constraints *constraints = NULL;
-
 	/*Recover pointer: */
-	constraints=*pconstraints;
+	Constraints* constraints=*pconstraints;
 
 	/*Create constraints if they do not exist yet*/
 	if(!constraints) constraints = new Constraints();
 	IoModelToConstraintsx(constraints,iomodel,HydrologySpcwatercolumnEnum,HydrologyAnalysisEnum);
-	
+
 	/*Assign output pointer: */
 	*pconstraints=constraints;
Index: issm/trunk/src/c/modules/ModelProcessorx/Hydrology/CreateLoadsHydrology.cpp
===================================================================
--- issm/trunk/src/c/modules/ModelProcessorx/Hydrology/CreateLoadsHydrology.cpp	(revision 13405)
+++ issm/trunk/src/c/modules/ModelProcessorx/Hydrology/CreateLoadsHydrology.cpp	(revision 13975)
@@ -13,12 +13,6 @@
 void	CreateLoadsHydrology(Loads** ploads, IoModel* iomodel){
 
-	/*Intermediary*/
-	int i;
-
-	/*DataSet*/
-	Loads*    loads    = NULL;
-
 	/*Recover pointer: */
-	loads=*ploads;
+	Loads* loads=*ploads;
 
 	/*Create loads if they do not exist yet*/
Index: issm/trunk/src/c/modules/ModelProcessorx/Hydrology/CreateNodesHydrology.cpp
===================================================================
--- issm/trunk/src/c/modules/ModelProcessorx/Hydrology/CreateNodesHydrology.cpp	(revision 13405)
+++ issm/trunk/src/c/modules/ModelProcessorx/Hydrology/CreateNodesHydrology.cpp	(revision 13975)
@@ -20,12 +20,9 @@
 	int    numberofvertices;
 
-	/*DataSets: */
-	Nodes*    nodes = NULL;
-
 	/*Fetch parameters: */
 	iomodel->Constant(&numberofvertices,MeshNumberofverticesEnum);
-	
+
 	/*Recover pointer: */
-	nodes=*pnodes;
+	Nodes* nodes=*pnodes;
 
 	/*Create nodes if they do not exist yet*/
@@ -46,5 +43,5 @@
 	}
 	iomodel->DeleteData(6,MeshVertexonbedEnum,MeshVertexonsurfaceEnum,MaskVertexongroundediceEnum,MaskVertexonfloatingiceEnum,FlowequationVertexEquationEnum,MaskVertexonwaterEnum);
-	
+
 	/*Assign output pointer: */
 	*pnodes=nodes;
Index: issm/trunk/src/c/modules/ModelProcessorx/Melting/CreateConstraintsMelting.cpp
===================================================================
--- issm/trunk/src/c/modules/ModelProcessorx/Melting/CreateConstraintsMelting.cpp	(revision 13405)
+++ issm/trunk/src/c/modules/ModelProcessorx/Melting/CreateConstraintsMelting.cpp	(revision 13975)
@@ -13,13 +13,6 @@
 void	CreateConstraintsMelting(Constraints** pconstraints, IoModel* iomodel){
 
-	/*Intermediary*/
-	int i;
-	int count;
-	
-	/*Intermediary*/
-	Constraints* constraints = NULL;
-
 	/*Recover pointer: */
-	constraints=*pconstraints;
+	Constraints* constraints=*pconstraints;
 
 	/*Create constraints if they do not exist yet*/
Index: issm/trunk/src/c/modules/ModelProcessorx/Melting/CreateLoadsMelting.cpp
===================================================================
--- issm/trunk/src/c/modules/ModelProcessorx/Melting/CreateLoadsMelting.cpp	(revision 13405)
+++ issm/trunk/src/c/modules/ModelProcessorx/Melting/CreateLoadsMelting.cpp	(revision 13975)
@@ -14,12 +14,6 @@
 
 	/*Intermediary*/
-	int i;
-	int    dim;
-	int    numberofvertices;
-
-	/*DataSet*/
-	Loads*    loads    = NULL;
-
-	/*Fetch parameters: */
+	int dim;
+	int numberofvertices;
 	iomodel->Constant(&dim,MeshDimensionEnum);
 	iomodel->Constant(&numberofvertices,MeshNumberofverticesEnum);
@@ -29,5 +23,5 @@
 
 	/*Recover pointer: */
-	loads=*ploads;
+	Loads* loads=*ploads;
 
 	/*Create loads if they do not exist yet*/
@@ -38,5 +32,5 @@
 	CreateSingleNodeToElementConnectivity(iomodel);
 
-	for (i=0;i<numberofvertices;i++){
+	for(int i=0;i<numberofvertices;i++){
 		if((iomodel->my_vertices[i]==1)){
 			if (reCast<int>(iomodel->Data(MeshVertexonbedEnum)[i])){
Index: issm/trunk/src/c/modules/ModelProcessorx/Melting/CreateNodesMelting.cpp
===================================================================
--- issm/trunk/src/c/modules/ModelProcessorx/Melting/CreateNodesMelting.cpp	(revision 13405)
+++ issm/trunk/src/c/modules/ModelProcessorx/Melting/CreateNodesMelting.cpp	(revision 13975)
@@ -20,12 +20,9 @@
 	int    numberofvertices;
 
-	/*DataSets: */
-	Nodes*    nodes = NULL;
-	
 	/*Fetch parameters: */
 	iomodel->Constant(&numberofvertices,MeshNumberofverticesEnum);
 
 	/*Recover pointer: */
-	nodes=*pnodes;
+	Nodes* nodes=*pnodes;
 
 	/*Create nodes if they do not exist yet*/
@@ -40,5 +37,5 @@
 
 		if(iomodel->my_vertices[i]){
-			
+
 			/*Add node to nodes dataset: */
 			nodes->AddObject(new Node(iomodel->nodecounter+i+1,i,i+1,i,iomodel,MeltingAnalysisEnum));
Index: issm/trunk/src/c/modules/ModelProcessorx/ModelProcessorx.cpp
===================================================================
--- issm/trunk/src/c/modules/ModelProcessorx/ModelProcessorx.cpp	(revision 13405)
+++ issm/trunk/src/c/modules/ModelProcessorx/ModelProcessorx.cpp	(revision 13975)
@@ -20,6 +20,6 @@
 
 	int   i,analysis_type,dim,verbose;
-	bool  isthermal,isprognostic,isdiagnostic,isgroundingline,isenthalpy,autodiff;
-	
+	bool  isthermal,isprognostic,isdiagnostic,isgroundingline,isenthalpy;
+
 	/*output: */
 	Elements    *elements    = NULL;
@@ -31,5 +31,4 @@
 	Parameters  *parameters  = NULL;
 
-	
 	/*Initialize IoModel from input file*/
 	IoModel* iomodel = new IoModel(IOMODEL);
@@ -43,10 +42,4 @@
 	iomodel->Constant(&isdiagnostic,TransientIsdiagnosticEnum);
 	iomodel->Constant(&isgroundingline,TransientIsgroundinglineEnum);
-	iomodel->Constant(&autodiff,AutodiffIsautodiffEnum);
-
-	/*If we are running in AD mode, we need to declare our independent variables now, before 
-	 *and prevent them from being erased during successive calls to iomodel->FetchData and 
-	 iomodel->DeleteData:*/
-	if(autodiff)iomodel->DeclareIndependents();
 
 	SetVerbosityLevel(verbose);
@@ -73,5 +66,5 @@
 		if(solution_type==SteadystateSolutionEnum && analysis_type==MeltingAnalysisEnum && isenthalpy==true) continue;
 		if(solution_type==SteadystateSolutionEnum && analysis_type==EnthalpyAnalysisEnum && isenthalpy==false) continue;
-	
+
 		if(VerboseMProcessor()) _pprintLine_("   creating datasets for analysis " << EnumToStringx(analysis_type));
 		CreateDataSets(&elements,&nodes,&vertices,&materials,&constraints,&loads,&parameters,iomodel,rootpath,solution_type,analysis_type,nummodels,i);
Index: issm/trunk/src/c/modules/ModelProcessorx/Prognostic/CreateConstraintsPrognostic.cpp
===================================================================
--- issm/trunk/src/c/modules/ModelProcessorx/Prognostic/CreateConstraintsPrognostic.cpp	(revision 13405)
+++ issm/trunk/src/c/modules/ModelProcessorx/Prognostic/CreateConstraintsPrognostic.cpp	(revision 13975)
@@ -10,14 +10,10 @@
 void	CreateConstraintsPrognostic(Constraints** pconstraints, IoModel* iomodel){
 
+	/*Fetch parameters: */
 	int stabilization;
-	
-	/*Fetch parameters: */
 	iomodel->Constant(&stabilization,PrognosticStabilizationEnum);
 
-	/*Output*/
-	Constraints *constraints = NULL;
-
 	/*Recover pointer: */
-	constraints=*pconstraints;
+	Constraints* constraints=*pconstraints;
 
 	/*Create constraints if they do not exist yet*/
Index: issm/trunk/src/c/modules/ModelProcessorx/Prognostic/CreateLoadsPrognostic.cpp
===================================================================
--- issm/trunk/src/c/modules/ModelProcessorx/Prognostic/CreateLoadsPrognostic.cpp	(revision 13405)
+++ issm/trunk/src/c/modules/ModelProcessorx/Prognostic/CreateLoadsPrognostic.cpp	(revision 13975)
@@ -23,7 +23,4 @@
 	int numberofelements;
 
-	/*DataSet*/
-	Loads*    loads    = NULL;
-	
 	/*Fetch parameters: */
 	iomodel->Constant(&stabilization,PrognosticStabilizationEnum);
@@ -32,5 +29,5 @@
 
 	/*Recover pointer: */
-	loads=*ploads;
+	Loads* loads=*ploads;
 
 	/*Create loads if they do not exist yet*/
Index: issm/trunk/src/c/modules/ModelProcessorx/Prognostic/CreateNodesPrognostic.cpp
===================================================================
--- issm/trunk/src/c/modules/ModelProcessorx/Prognostic/CreateNodesPrognostic.cpp	(revision 13405)
+++ issm/trunk/src/c/modules/ModelProcessorx/Prognostic/CreateNodesPrognostic.cpp	(revision 13975)
@@ -26,7 +26,4 @@
 	int    stabilization;
 
-	/*DataSets: */
-	Nodes*    nodes = NULL;
-
 	/*Fetch parameters: */
 	iomodel->Constant(&dim,MeshDimensionEnum);
@@ -36,5 +33,5 @@
 
 	/*Recover pointer: */
-	nodes=*pnodes;
+	Nodes* nodes=*pnodes;
 
 	/*Create nodes if they do not exist yet*/
Index: issm/trunk/src/c/modules/ModelProcessorx/Prognostic/UpdateElementsPrognostic.cpp
===================================================================
--- issm/trunk/src/c/modules/ModelProcessorx/Prognostic/UpdateElementsPrognostic.cpp	(revision 13405)
+++ issm/trunk/src/c/modules/ModelProcessorx/Prognostic/UpdateElementsPrognostic.cpp	(revision 13975)
@@ -73,4 +73,6 @@
 	if(issmbgradients){
 	        iomodel->FetchDataToInput(elements,SurfaceforcingsHcEnum);
+	        iomodel->FetchDataToInput(elements,SurfaceforcingsHrefEnum);
+	        iomodel->FetchDataToInput(elements,SurfaceforcingsSmbrefEnum);
 	        iomodel->FetchDataToInput(elements,SurfaceforcingsSmbPosMaxEnum);
 	        iomodel->FetchDataToInput(elements,SurfaceforcingsSmbPosMinEnum);
Index: issm/trunk/src/c/modules/ModelProcessorx/SurfaceSlope/CreateConstraintsSurfaceSlope.cpp
===================================================================
--- issm/trunk/src/c/modules/ModelProcessorx/SurfaceSlope/CreateConstraintsSurfaceSlope.cpp	(revision 13405)
+++ issm/trunk/src/c/modules/ModelProcessorx/SurfaceSlope/CreateConstraintsSurfaceSlope.cpp	(revision 13975)
@@ -13,9 +13,6 @@
 void	CreateConstraintsSurfaceSlope(Constraints** pconstraints, IoModel* iomodel){
 
-	/*Output*/
-	Constraints* constraints = NULL;
-	
 	/*Recover pointer: */
-	constraints=*pconstraints;
+	Constraints* constraints=*pconstraints;
 
 	/*Create constraints if they do not exist yet*/
Index: issm/trunk/src/c/modules/ModelProcessorx/SurfaceSlope/CreateLoadsSurfaceSlope.cpp
===================================================================
--- issm/trunk/src/c/modules/ModelProcessorx/SurfaceSlope/CreateLoadsSurfaceSlope.cpp	(revision 13405)
+++ issm/trunk/src/c/modules/ModelProcessorx/SurfaceSlope/CreateLoadsSurfaceSlope.cpp	(revision 13975)
@@ -13,9 +13,6 @@
 void	CreateLoadsSurfaceSlope(Loads** ploads, IoModel* iomodel){
 
-	/*DataSet*/
-	Loads*    loads    = NULL;
-
 	/*Recover pointer: */
-	loads=*ploads;
+	Loads* loads=*ploads;
 
 	/*Create loads if they do not exist yet*/
Index: issm/trunk/src/c/modules/ModelProcessorx/SurfaceSlope/CreateNodesSurfaceSlope.cpp
===================================================================
--- issm/trunk/src/c/modules/ModelProcessorx/SurfaceSlope/CreateNodesSurfaceSlope.cpp	(revision 13405)
+++ issm/trunk/src/c/modules/ModelProcessorx/SurfaceSlope/CreateNodesSurfaceSlope.cpp	(revision 13975)
@@ -16,10 +16,6 @@
 
 	/*Intermediary*/
-	int i;
 	bool continuous_galerkin=true;
 	int    numberofvertices;
-
-	/*DataSets: */
-	Nodes*    nodes = NULL;
 
 	/*Fetch parameters: */
@@ -27,19 +23,18 @@
 
 	/*Recover pointer: */
-	nodes=*pnodes;
+	Nodes* nodes=*pnodes;
 
 	/*Create nodes if they do not exist yet*/
 	if(!nodes) nodes = new Nodes();
-	
+
 	/*Continuous Galerkin partition of nodes: */
 	NodesPartitioning(&iomodel->my_nodes,iomodel->my_elements,iomodel->my_vertices,iomodel,continuous_galerkin);
-	
+
 	/*First fetch data: */
 	iomodel->FetchData(6,MeshVertexonbedEnum,MeshVertexonsurfaceEnum,MaskVertexongroundediceEnum,MaskVertexonfloatingiceEnum,FlowequationVertexEquationEnum,MaskVertexonwaterEnum);
 
-	for (i=0;i<numberofvertices;i++){
+	for(int i=0;i<numberofvertices;i++){
+		if(iomodel->my_vertices[i]){
 
-		if(iomodel->my_vertices[i]){
-			
 			/*Add node to nodes dataset: */
 			nodes->AddObject(new Node(iomodel->nodecounter+i+1,i,i+1,i,iomodel,SurfaceSlopeAnalysisEnum));
@@ -50,5 +45,5 @@
 	/*Clean fetched data: */
 	iomodel->DeleteData(6,MeshVertexonbedEnum,MeshVertexonsurfaceEnum,MaskVertexongroundediceEnum,MaskVertexonfloatingiceEnum,FlowequationVertexEquationEnum,MaskVertexonwaterEnum);
-	
+
 	/*Assign output pointer: */
 	*pnodes=nodes;
Index: issm/trunk/src/c/modules/ModelProcessorx/Thermal/CreateConstraintsThermal.cpp
===================================================================
--- issm/trunk/src/c/modules/ModelProcessorx/Thermal/CreateConstraintsThermal.cpp	(revision 13405)
+++ issm/trunk/src/c/modules/ModelProcessorx/Thermal/CreateConstraintsThermal.cpp	(revision 13975)
@@ -14,17 +14,10 @@
 void	CreateConstraintsThermal(Constraints** pconstraints, IoModel* iomodel){
 
-	/*Intermediary*/
-	int i;
-	int count;
+	/*Fetch parameters: */
 	int    dim;
-	
-	/*Output*/
-	Constraints* constraints = NULL;
-
-	/*Fetch parameters: */
 	iomodel->Constant(&dim,MeshDimensionEnum);
 
 	/*Recover pointer: */
-	constraints=*pconstraints;
+	Constraints* constraints=*pconstraints;
 
 	/*Create constraints if they do not exist yet*/
Index: issm/trunk/src/c/modules/ModelProcessorx/Thermal/CreateLoadsThermal.cpp
===================================================================
--- issm/trunk/src/c/modules/ModelProcessorx/Thermal/CreateLoadsThermal.cpp	(revision 13405)
+++ issm/trunk/src/c/modules/ModelProcessorx/Thermal/CreateLoadsThermal.cpp	(revision 13975)
@@ -17,11 +17,8 @@
 	int    dim;
 	int    numberofvertices;
-
-	/*DataSet*/
-	Loads*    loads    = NULL;
 	Pengrid*    pengrid  = NULL;
 
 	/*Recover pointer: */
-	loads=*ploads;
+	Loads* loads=*ploads;
 
 	/*Fetch parameters: */
@@ -40,5 +37,5 @@
 
 	for (i=0;i<numberofvertices;i++){
-	
+
 		/*keep only this partition's nodes:*/
 		if((iomodel->my_vertices[i]==1)){
